stages:
  - dockerize
  - deploy

dockerize:
  stage: dockerize
  image: docker:latest
  services:
    - docker:dind
  script:
    - touch .env
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
    - docker build
      --pull -t $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_SLUG

deploy:
  stage: deploy
  image: instrumentisto/rsync-ssh
  only:
    - tags
  script:
    # Add key
    - eval $(ssh-agent -s)
    - echo "$DEPLOYER_KEY" | tr -d '\r' | ssh-add - > /dev/null
    - mkdir -p ~/.ssh
    - chmod 700 ~/.ssh
    # Remove known hosts check
    - echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config
    # Move docker-compose file to host
    - sed -i 's/TAG/'$CI_COMMIT_REF_SLUG'/g' docker-compose.prod.yml
    - scp ./docker-compose.prod.yml deployer@80.235.41.10:/srv/docker/sc-api/docker-compose.yml
    # Deploy it
    - ssh -t deployer@80.235.41.10 "docker login -u $CI_DEPLOY_USER -p $CI_DEPLOY_PASSWORD $CI_REGISTRY &&
      cd /srv/docker/sc-api &&
      APP_KEY="$APP_KEY"
      SC_PROXY_URL="$SC_PROXY_URL"
      SC_API_URL="$SC_API_URL"
      ADMIN_USER="$ADMIN_USER"
      ADMIN_PASSWORD="$ADMIN_PASSWORD"
      docker-compose up -d &&

      docker-compose exec -T api node ace migration:run --force"
